/* SofChat (Web Chat program SHM version)      */
/* Copyright(c) 1996-1997 Y.YONEYAMA           */
/*                                             */
/* code.c                                      */

char *pkey = PASSWORD;

static int getpkey(i)
int i;
{
  return((pkey[i%strlen(pkey)] - 0x20)&0x1f);
}

void code(dst, src)
char *dst;
char *src;
{
  int i, m, rkey;

  if(!(*src == '@' && *(src+1) == '*'))
  {
    *(dst++) = '@';
    *(dst++) = '*';
    srand(time(0));
    rkey = rand()&0x0f;
    *(dst++) = 'A' + rkey;
    m = strlen(src);
    for(i=0;i<m;i++)
    {
      unsigned int d;
      d = (((src[i]&0x7f)+getpkey(rkey+i))<<3) | (rand()&0x07);
      *(dst++) = 0x40 | ((d>>6)&0x3f);
      *(dst++) = 0x40 | (d&0x3f);
    }
    *dst = '\0';
  }
  else
  {
    strcpy(dst, src);
  }
}

void decode(dst, src)
char *dst;
char *src;
{
  int i;
  if(*src == '@' && *(src+1) == '*')
  {
    int rkey;
    src += 2;
    rkey = *(src++) - 'A';
    for(i=0;i<strlen(src);i+=2)
    {
      unsigned int d;
      d = ((src[i]&0x3f)<<6)|(src[i+1]&0x3f);
      d = (d>>3) - getpkey(rkey+i/2);
      *(dst++) = (d&0x7f);
    }
    *dst = '\0';
  }
  else
  {
    strcpy(dst, src);
  }
}

